!* --------------------------------------------------------------  */
!* (C)Copyright 2006,2008,                                         */
!* International Business Machines Corporation                     */
!* All Rights Reserved.                                            */
!*                                                                 */
!* Redistribution and use in source and binary forms, with or      */
!* without modification, are permitted provided that the           */
!* following conditions are met:                                   */
!*                                                                 */
!* - Redistributions of source code must retain the above copyright*/
!*   notice, this list of conditions and the following disclaimer. */
!*                                                                 */
!* - Redistributions in binary form must reproduce the above       */
!*   copyright notice, this list of conditions and the following   */
!*   disclaimer in the documentation and/or other materials        */
!*   provided with the distribution.                               */
!*                                                                 */
!* - Neither the name of IBM Corporation nor the names of its      */
!*   contributors may be used to endorse or promote products       */
!*   derived from this software without specific prior written     */
!*   permission.                                                   */
!*                                                                 */
!* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
!* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
!* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
!* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
!* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
!* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
!* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
!* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
!* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
!* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
!* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
!* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
!* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
!* --------------------------------------------------------------  */
!* PROLOG END TAG zYx                                              */
!
!
! Example:     3 - dacs_f Cell
! Language:    IBM XL Fortran
! Core:        Included by SPU PPU
! File:        init_cb.h
! Description: Constants and control block definition
!

!     Constants can be modified to change the number of SPUs and the number of elements per SPU
      integer(kind=dacs_int32_t), parameter :: MIN_UNIT_SIZE       = 8   !min elements per spu - must be 8 16 32 64 (power of 2, between 8 and 64
      integer(kind=dacs_int32_t), parameter :: MAX_UNIT_COUNT      = 8   !max spus - must be between 1 and 8 for this sample
      integer(kind=dacs_int32_t), parameter :: DATA_BUFFER_ENTRIES = 64  !array element count - must be a multple of 8
      integer(kind=dacs_int32_t), parameter :: REAL_SIZE           = 4   !array element size - in bytes
      integer(kind=dacs_int64_t), parameter :: DATA_BUFFER_SIZE    = DATA_BUFFER_ENTRIES*REAL_SIZE !array size in bytes

      integer(kind=dacs_stream_t), parameter :: STREAM_ID = 1  !dacs send/receive correlation id

      type control_block_t
        sequence
        integer(kind=8) :: chunk_size  !size, in bytes, of each of these array pieces
        integer(kind=8) :: offset      !offset of array piece
        integer(kind=8) :: index       !chunk index for tracking
        integer(kind=8) :: pad;        !pad maintain alignment
      end type control_block_t


