/* --------------------------------------------------------------  */
/* (C)Copyright 2006,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
//
// Example:     3 - dacs_f Cell
// Language:    IBM XL C
// Core:        SPU
// File:        spu_print.c
// Description: Provide common print capability for Fortran SPU code
//

//simple C printf for use by Fortran until spuxlf supports print and write Fortran statements
#include <stdio.h>
#include <stdlib.h>

//for all functions last character of the string is replaced with a NULL for printing in C

//the Fortran compiler appends the length of the string as a parameter in the interoperability call to C

//print string
extern void spu_print_(char * estg,int len)
{

   *(estg+len-1)='\0';
   printf("%s\n", estg);
   fflush(stdout);

}

//print spu index prefix and string
extern void spui_print_(char * estg,long long * index_ptr,int len)
{

   *(estg+len-1)='\0';
   printf("spu unit. %lli %s\n", *index_ptr,estg);
   fflush(stdout);

}

//print integer in format: string[int32]
extern void spu_print32_(char * stg,int* val_ptr, int len)
{

   *(stg+len-1)='\0';
   printf("%s[%d]\n", stg,*val_ptr);
   fflush(stdout);

}

//print 64 bit integer as hex in format: string[int64]
extern void spu_print64_(char * stg,long long* val_ptr, int len)
{

   *(stg+len-1)='\0';
   printf("%s[0x%016llx]\n", stg,*val_ptr);
   fflush(stdout);

}

//print integer of type float in format: string[int]
extern void spu_printr_(char * stg,float* val_ptr, int len)
{
   *(stg+len-1)='\0';
   int i = (int)(*val_ptr);
   printf("%s[%d]\n", stg,i);
   fflush(stdout);

}
