!* --------------------------------------------------------------  */
!* (C)Copyright 2006,2008,                                         */
!* International Business Machines Corporation                     */
!* All Rights Reserved.                                            */
!*                                                                 */
!* Redistribution and use in source and binary forms, with or      */
!* without modification, are permitted provided that the           */
!* following conditions are met:                                   */
!*                                                                 */
!* - Redistributions of source code must retain the above copyright*/
!*   notice, this list of conditions and the following disclaimer. */
!*                                                                 */
!* - Redistributions in binary form must reproduce the above       */
!*   copyright notice, this list of conditions and the following   */
!*   disclaimer in the documentation and/or other materials        */
!*   provided with the distribution.                               */
!*                                                                 */
!* - Neither the name of IBM Corporation nor the names of its      */
!*   contributors may be used to endorse or promote products       */
!*   derived from this software without specific prior written     */
!*   permission.                                                   */
!*                                                                 */
!* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
!* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
!* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
!* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
!* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
!* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
!* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
!* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
!* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
!* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
!* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
!* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
!* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
!* --------------------------------------------------------------  */
!* PROLOG END TAG zYx                                              */
!
!
! Example:     1 - spe2_c Cell
! Language:    IBM XL Fortran
! Core:        PPU
! File:        main_ppu.f90
! Description: Main PPU program - initiates and terminates example,
!              invokes C function in ppu_array.c to communicate with the SPUs.
!

!
! Main Fortran program - uses array language to perform computation.
! Call c function to communicate with the SPUs
!
program main
  integer, parameter :: N=64  !must match DATA_BUFFER_ENTRIES in init_cb.h
  real :: arr(N)
  interface
    subroutine update_array(x, i)
    real x(N)
    integer, value :: i
    end subroutine
  end interface

  arr = (/(real(i),i=1, N)/);
  write(*,'(A)') 'PPE: initial array value'
  write(*,'(8f6.1)') arr

! c function will share the array to the 8 spus
  call update_array(arr, N)

  write(*,'(A)') 'PPE: final array value'
  write(*,'(8f6.1)') arr
end program
