/* --------------------------------------------------------------  */
/* (C)Copyright 2006,2008,                                         */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
//
// Example:     1 - spe2_c Cell
// Language:    IBM XL C
// Core:        Included by SPU PPU
// File:        init_cb.h
// Description: Constants and control block definition
//

#ifndef _INIT_CB_H_
#define _INIT_CB_H_

#define DATA_BUFFER_ENTRIES     64  //array element count - must be a multple of 8
#define DATA_BUFFER_SIZE        DATA_BUFFER_ENTRIES*sizeof(float)  //array size in bytes
#define UNIT_SIZE               8   //number of elements processed by each spu
#define UNIT_BUFFER_SIZE        UNIT_SIZE*sizeof(float)   // size of buffer for each spu
#define UNIT_COUNT              DATA_BUFFER_ENTRIES/UNIT_SIZE //number of buffers to be processed

//This union helps clarify calling parameters between the PPE and the SPE.
typedef union {
  unsigned long long ull;
  unsigned int ui[2];
  void *p;
} addr64;

typedef struct _control_block {
  unsigned int  chunk_size; //size, in bytes, of each of these array pieces
  unsigned char pad[4];     //pad maintain alignment and sized for correct DMA
  addr64 addr;              //address to be filled by single-buffered DMA
} control_block;

#endif
